Magellan Linux

Diff of /tags/installer-simple-0_4_90_20140703_1/bin/installer.sh.in

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 2432 by niro, Tue Jan 7 14:17:00 2014 UTC revision 2482 by niro, Wed Jan 8 10:32:55 2014 UTC
# Line 7  Line 7 
7  # Niels Rogalla <niro@magellan-linux.de>  # Niels Rogalla <niro@magellan-linux.de>
8  #  #
9    
10  # ignore the environment  # setup locales
11  LC_ALL=C  TEXTDOMAIN=installer
12    LC_MESSAGES=C
13    
14  # include dir  # include dir
15  INSTALLER_LIBDIR="%LIBDIR%"  INSTALLER_LIBDIR="%LIBDIR%"
16    
# Line 70  SPECIALDEVICE="" Line 72  SPECIALDEVICE=""
72  FORMFACTOR="${DEFAULT_FORMFACTOR}"  FORMFACTOR="${DEFAULT_FORMFACTOR}"
73  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"  FORMAT_FILESYSTEM="${DEFAULT_FILESYSTEM}"
74    
75  #################################################  
76  #  DIALOG BOXEN #  ### helper scripts ###
 #################################################  
77    
78  trap_exit()  trap_exit()
79  {  {
# Line 86  trap_exit() Line 87  trap_exit()
87   exit 1   exit 1
88  }  }
89    
 dialog_die()  
 {  
  ERROR="$1"  
  RETVAL="$?"  
  dialog_install_failure  
  exit 1  
 }  
   
 dialog_warning()  
 {  
  local retval  
   
  yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"  
  retval=$?  
  if [[ ${retval} -eq 1 ]]  
  then  
  clear  
  echo $"The process was aborted."  
  exit 1  
  fi  
 }  
   
 dialog_setup_hdd_info()  
 {  
  local SHDD="${HDD//\/dev\/}"  
   
  messagebox -h $"[ Harddrive partitioning ]" \  
  $"\nPlease create 1 partition.\n\n\[ \Z3${SHDD}1\Zn ] type: \Z3linux\Zn with the whole diskspace\n\Please mark ${SHDD}1 \Z3bootable\Zn."  
 }  
   
 dialog_setup_hdd_info_auto()  
 {  
  local SHDD="${HDD//\/dev\/}"  
   
  messagebox -h $"[ Harddrive partitioning ]" \  
  $"\Z1Warning!\Zn\n\nAll data on disk [ \Z3${HDD}\Zn ] will be erased!"  
 }  
   
 dialog_setup_system_menu()  
 {  
  local mode  
  local retval  
   
  mode=$(menubox -h $"[ Harddrive partitioning ]" $"\nSelect an installation mode" \  
  $"1:Automatic setup (recommended)" \  
  ":" \  
  $":\Z1Expert modes:\Zn" \  
  $"2:Common IDE-disk (manual setup)")  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case "${mode}" in  
  "1") run_install_auto ;;  
  "2") run_install_normal ;;  
  "") dialog_setup_system_menu;;  
  esac  
  fi  
 }  
   
 dialog_hardware_detection()  
 {  
  local message  
   
  run_hardware_detection_disks  
   
  message+=$"Harddrives:\n"  
   
  if [[ ! -z ${ALL_DISKS} ]]  
  then  
  for i in ${ALL_DISKS}  
  do  
  message+="\Z3${i}\Zn "  
  done  
  message+="\n"  
  fi  
   
  if [[ ! -z ${ALL_CDROMS} ]]  
  then  
  message+="\n"  
  message+=$"Optical disk drives:\n"  
  for i in ${ALL_CDROMS}  
  do  
  message+="\Z3${i}\Zn"  
  done  
  message+="\n"  
  fi  
   
  # other devices  
  run_hardware_detection  
  case "${SPECIALDEVICE}" in  
  zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;  
  rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;  
  maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;  
  *) message+=$"\n \\ZnCommon device detected.\Zn" ;;  
  esac  
  if [[ ${FORMFACTOR} = laptop ]]  
  then  
  message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving  mode.\Zn"  
  fi  
   
  messagebox -y 15 -h $"Detected hardware:" "${message}"  
 }  
   
 dialog_setup_hdd_partitions_manual()  
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
  then  
  dialog_no_harddrive_found  
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info  
  setup_hdd_partitions_manual  
  fi  
  fi  
 }  
   
 dialog_setup_hdd_partitions_auto()  
 {  
  local i  
  local retval  
   
  if [[ -z ${ALL_DISKS} ]]  
  then  
  dialog_no_harddrive_found  
  exit 1  
  else  
  HDD=$(dialog_select_target_harddrive)  
  retval=$?  
  [[ ${retval} -eq 1 ]] && return 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  dialog_setup_hdd_info_auto  
  dialog_setup_hdd_create_partitions  
  setup_hdd_partitions_auto  
  fi  
  fi  
 }  
   
90  install_meter()  install_meter()
91  {  {
92   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]   while [[ ${CURRENTLINE} != ${TOTALLINES} ]]
# Line 246  install_meter() Line 100  install_meter()
100   return 0   return 0
101  }  }
102    
 dialog_main()  
 {  
  local method=0  
  local retval  
103    
  while [[ ${method} -le 2 ]]  
  do  
  method=$(menubox $"Configuration:" \  
  $"1:Install system" \  
  $"2:Show detected harddrives" \  
  $"3:Exit and reboot" \  
  $"4:Exit and drop into a shell")  
  retval=$?  
  [[ ${retval} -eq 1 ]] && exit 1  
  if [[ ${retval} -eq 0 ]]  
  then  
  case ${method} in  
  "1") dialog_setup_system_menu ;;  
  "2") dialog_hardware_detection ;;  
  "3") install_do_reboot ;;  
  "4") /bin/bash --login -i ;;  
  esac  
  fi  
  done  
 }  
   
 #################################################  
 # Install Komandos #  
 #################################################  
104  run_hardware_detection()  run_hardware_detection()
105  {  {
106   local hwinfo   local hwinfo
# Line 348  run_hardware_detection_disks() Line 174  run_hardware_detection_disks()
174   export ALL_CDROMS="$(get_hwinfo cdrom)"   export ALL_CDROMS="$(get_hwinfo cdrom)"
175  }  }
176    
177  hdd_size_below_256mb()  setup_hdd_partitions_auto()
178  {  {
179   local hdd="$1"   ROOTHDD="${HDD}1"
  local size  
  local retval  
  [[ -z ${hdd} ]] && dialog_die "Error: get_hdd_size() no \$hdd given!"  
180    
181   size=$(fdisk -l ${hdd} | grep "Disk.*${hdd}" | sed 's:.*,\ \(.*\)\ byte.*:\1:')   # sanity check - should not happen
182   if [[ ${size} -le 257000000 ]]   if is_mounted --device "${ROOTHDD}"
183   then   then
184   retval="0"   echo "partition: device ${ROOTHDD} is already mounted, umount it" >&2
185   else   umount "${ROOTHDD}"
  retval="1"  
186   fi   fi
187    
  return "${retval}"  
 }  
   
 setup_hdd_partitions_auto()  
 {  
  ROOTHDD="${HDD}1"  
   
188   # run this only if FDISKPARTITIONBELOW256MB is not already 1   # run this only if FDISKPARTITIONBELOW256MB is not already 1
189   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]   if [[ ${FDISKPARTIONBELOW256MB} != 1 ]]
190   then   then
# Line 431  EOF Line 246  EOF
246  setup_hdd_partitions_manual()  setup_hdd_partitions_manual()
247  {  {
248   ROOTHDD="${HDD}1"   ROOTHDD="${HDD}1"
249     SWAPHDD=""
250   ## hdds partitionieren manual   BOOTHDD=""
251   cfdisk ${HDD} || dialog_die   cfdisk ${HDD} || dialog_die
252  }  }
253    
254  setup_hdd_format()  setup_hdd_format()
255  {  {
256     # sanity check - should not happen
257     if is_mounted --device "${ROOTHDD}"
258     then
259     echo "format: device ${ROOTHDD} is already mounted, umount it" >&2
260     umount "${ROOTHDD}"
261     fi
262    
263   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die   mkfs."${FORMAT_FILESYSTEM}" -q "${ROOTHDD}" || dialog_die
264  }  }
265    
266  install_mount_rootfs()  install_mount_rootfs()
267  {  {
268   mount ${ROOTHDD} ${INSTALLROOT} || dialog_die   is_mounted --location "${INSTALLROOT}" || mount "${ROOTHDD}" "${INSTALLROOT}"
269   install -d ${INSTALLROOT}/boot || dialog_die   install -d ${INSTALLROOT}/boot || dialog_die
  cd ${INSTALLROOT} || dialog_die  
270  }  }
271    
272  install_system_image()  install_system_image()
273  {  {
274     pushd ${INSTALLROOT} > /dev/null
275   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}   tar xvjpf ${CDROOT}/system/${CDIMAGENAME} -C ${INSTALLROOT}
276     popd > /dev/null
277  }  }
278    
279  install_bootsector_chroot()  install_system_settings()
280  {  {
281   local my_roothdd   local CONFIG
282   local grubconf=${INSTALLROOT}/boot/grub/grub.conf  
283   local grub2conf=/boot/grub/grub.cfg   # write fstab
284     CONFIG="${INSTALLROOT}/etc/fstab"
285     clearconfig
286     addconfig -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime,noauto\t1 1"
287     addconfig -e "proc\t/proc\tproc\tdefaults\t0 0"
288     addconfig -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0"
289    
290   # check for grub2   # install network config skeleton
291   if [[ -f ${INSTALLROOT}/sbin/grub-mkconfig ]]   CONFIG="${INSTALLROOT}/etc/conf.d/net.eth0"
292     clearconfig
293     addconfig 'ONBOOT="yes"'
294     addconfig 'NETWORKING="dhcp"'
295    
296     # intel framebuffer quirk
297     if [ -e ${INSTALLROOT}/etc/splash/splash.conf ]
298   then   then
299   # needed by grub-mkconfig on the first run   if [ -e /proc/fb ]
  if [[ ! -f ${INSTALLROOT}/boot/grub/video.lst ]]  
300   then   then
301   install -m0644 ${INSTALLROOT}/lib/grub/*/video.lst ${INSTALLROOT}/boot/grub/video.lst || dialog_die   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]
302     then
303     fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')
304     if [[ ${fbdev} != 0 ]]
305     then
306     sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die
307     fi
308     fi
309   fi   fi
310     fi
311    }
312    
313   # set kernelopts  install_umount_rootfs()
314   if [[ -f ${INSTALLROOT}/etc/conf.d/grub ]]  {
315   then   is_mounted --location ${INSTALLROOT}/boot && umount ${INSTALLROOT}/boot
316   sed -i "s:^\(export GRUB_CMDLINE_LINUX_DEFAULT=\).*:\1\"${KERNELOPTS}\":" ${INSTALLROOT}/etc/conf.d/grub || dialog_die   is_mounted --location ${INSTALLROOT} && umount ${INSTALLROOT}
317   else  }
  echo "export GRUB_CMDLINE_LINUX_DEFAULT=\"${KERNELOPTS}\"" >  ${INSTALLROOT}/etc/conf.d/grub || dialog_die  
  fi  
  echo 'grub-mkdevicemap' > ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "LC_ALL=C grub-mkconfig -o ${grub2conf}  &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "grub-install --no-floppy ${HDD} &> /dev/null" >> ${INSTALLROOT}/root/.installrc || dialog_die  
  echo "exit 0" >> ${INSTALLROOT}/root/.installrc || dialog_die  
318    
319   # grub-legacy  install_do_reboot()
320   else  {
321   ### grubconf schreiben   reboot
322   source ${INSTALLROOT}/boot/kernelversion  }
323    
  #for alx only  
  if [ -e ${INSTALLROOT}/etc/alx_version ]  
  then  
  OLD_ALXVER="${ALXVER}"  
  source ${INSTALLROOT}/etc/alx_version  
  KRNVER="ALX-${ALXVER}"  
  ALXVER="${OLD_ALXVER}"  
  fi  
324    
325   [[ -z ${KRNVER} ]] && KRNVER="AutoSta_LX"  ### installer dialogs ###
  [[ -z ${KRNINITRD} ]] && KRNINITRD="initrd"  
  [[ -z ${KRNIMG} ]] && KRNIMG="vmlinuz"  
326    
327   # uuid support  dialog_die()
328   if is_uuid_supported  {
329   then   ERROR="$1"
330   my_roothdd="UUID=$(get_uuid ${ROOTHDD})"   RETVAL="$?"
331   else   dialog_install_failure
332   my_roothdd="${ROOTHDD}"   exit 1
333   fi  }
334    
335   : > ${grubconf} || dialog_die  dialog_warning()
336   echo "default 0" >> ${grubconf} || dialog_die  {
337   echo "timeout 3" >> ${grubconf} || dialog_die   local retval
  # using current root password  
  echo "password --md5 $(cat ${INSTALLROOT}/etc/shadow | grep root | cut -d: -f2)"  >> ${grubconf} || dialog_die  
   
  echo  >> ${grubconf} || dialog_die  
  echo "# normal boot" >> ${grubconf} || dialog_die  
  echo "title ${KRNVER}" >> ${grubconf} || dialog_die  
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS}" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
338    
339   echo >> ${grubconf} || dialog_die   yesnobox $"\Z1 !!! Warning !!! \Zn\n\n\This harddrive will be irreversibly erased.\n\n\Do you want to continue ?"
340   echo "# admin boot" >> ${grubconf} || dialog_die   retval=$?
341   echo "title ${KRNVER} - Re-run hardware-detection" >> ${grubconf} || dialog_die   if [[ ${retval} -eq 1 ]]
342   echo "lock"  >> ${grubconf} || dialog_die   then
343   echo "root (hd0,0)" >> ${grubconf} || dialog_die   clear
344   echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} hardware-auto-detection" >> ${grubconf} || dialog_die   echo $"The process was aborted."
345   if is_initrd_supported   exit 1
346   then   fi
347   echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  }
  fi  
348    
  echo >> ${grubconf} || dialog_die  
  echo "title ${KRNVER} - Reset *all* local settings" >> ${grubconf} || dialog_die  
  echo "lock"  >> ${grubconf} || dialog_die  
  echo "root (hd0,0)" >> ${grubconf} || dialog_die  
  echo "kernel /boot/${KRNIMG} root=${my_roothdd} ${KERNELOPTS} ${GRUBLEGACYOPTS} alx-reset-settings" >> ${grubconf} || dialog_die  
  if is_initrd_supported  
  then  
  echo "initrd /boot/${KRNINITRD}" >> ${grubconf} || dialog_die  
  fi  
349    
350   # bootsector schreiben chrooted schreiben (lfs/magellan)  ### installer tasks ###
  cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF  
 /usr/sbin/grub --no-floppy --batch << "EOF" 1> /dev/null 2> /dev/null  
 root (hd0,0)  
 setup (hd0)  
 quit  
 EOF  
 exit 0  
 CHROOTEOF  
  fi  
351    
352   ## enter chroot  task_setup_system_menu()
353   mount -t proc proc ${INSTALLROOT}/proc  {
354   mount -t sysfs sysfs ${INSTALLROOT}/sys   local mode
355   mount -o bind /dev ${INSTALLROOT}/dev   local retval
  chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i  
  umount ${INSTALLROOT}/proc  
  umount ${INSTALLROOT}/sys  
  umount ${INSTALLROOT}/dev  
  rm ${INSTALLROOT}/root/.installrc  
 }  
   
 is_initrd_supported()  
 {  
  # only generate initrds if the cmd exists  
  [[ -x ${INSTALLROOT}/sbin/mkinitrd ]] && return 0  
  return 1  
 }  
   
 install_initrd_chroot()  
 {  
  # only generate initrds if the cmd exists  
  is_initrd_supported || return 0  
   
  DISKMODS="sd_mod"  
  OLDPATAMODS="amd74xx piix sis5513 via82cxxx"  
  PATAMODS="ata_piix pata_amd pata_mpiix pata_oldpiix pata_sis pata_via"  
  SATAMODS="sata_via sata_sis sata_nv"  
  DRMMODS="i915 mga nouveau r128 radeon savage sis tdfx ttm via"  
  OTHERMODS=""  
  case ${SPECIALDEVICE} in  
  zotac_intel) FBMODS=""; DRMMODS="i915" ;;  
  zotac_nvidia) FBMODS=""; DRMMODS="nouveau" ;;  
  rangee) FBMODS="" ;; ## fallback to vesafb, viafb does not run on all CLE266 boards  
  # not working with kms enabled drivers -> segfaults  
  #maxdata) FBMODS="i810fb" ;; ## check for maxdata / i810/ i815 Chipsets and disable KMS and use i810fb frambuffer  
  maxdata) FBMODS="" ;;  
  *) FBMODS="uvesafb" ;;  
  esac  
356    
357   if [[ ${FORMFACTOR} = laptop ]]   mode="$(dialog_setup_system_menu)"
358     retval=$?
359     [[ ${retval} -eq 1 ]] && return 1
360     if [[ ${retval} -eq 0 ]]
361   then   then
362   OTHERMODS="acpi-cpufreq cpufreq_ondemand cpufreq_conservative cpufreq_powersave"   case "${mode}" in
363     "1") run_install_auto ;;
364     "2") run_install_normal ;;
365     "") task_setup_system_menu;;
366     esac
367   fi   fi
368    }
369    
370   # install an appropriate uvesafb.conf  task_hardware_detection()
371   install -d ${INSTALLROOT}/etc/modprobe.d || dialog_die  {
372   echo "options uvesafb mode_option=1024x768-32@60 scroll=ywrap" > ${INSTALLROOT}/etc/modprobe.d/uvesafb.conf || dialog_die   local message
373    
374   # install an appropriate viafb.conf   run_hardware_detection_disks
  echo "options viafb viafb_mode=1024x768 viafb_refresh=60" > ${INSTALLROOT}/etc/modprobe.d/viafb.conf || dialog_die  
375    
376   # install an appropriate i810fb.conf   message+=$"Harddrives:\n"
  echo "options i810fb xres=1024 yres=768 bpp=16 mtrr=1 hsync1=30 hsync2=62 vsync1=30 vsync2=60"  > ${INSTALLROOT}/etc/modprobe.d/i810fb.conf || dialog_die  
377    
378   cat > ${INSTALLROOT}/root/.installrc << CHROOTEOF   if [[ ! -z ${ALL_DISKS} ]]
379  echo "MODULES=\"${FORMAT_FILESYSTEM} ${DISKMODS} ${OLDATAMODS} ${PATAMODS} ${SATAMODS} ${DRMMODS} ${FBMODS} ${OTHERMODS}\"" > /etc/conf.d/mkinitrd   then
380  mkinitrd -f /boot/$(readlink /boot/initrd) $(readlink /boot/vmlinuz | sed "s:kernel-::g") > /dev/null   for i in ${ALL_DISKS}
381  exit 0   do
382  CHROOTEOF   message+="\Z3${i}\Zn "
383     done
384     message+="\n"
385     fi
386    
387   ## enters chroot   if [[ ! -z ${ALL_CDROMS} ]]
388   mount -t proc proc ${INSTALLROOT}/proc   then
389   mount -t sysfs sysfs ${INSTALLROOT}/sys   message+="\n"
390   mount -o bind /dev ${INSTALLROOT}/dev   message+=$"Optical disk drives:\n"
391   chroot ${INSTALLROOT} /bin/bash --rcfile /root/.installrc -i   for i in ${ALL_CDROMS}
392   umount ${INSTALLROOT}/proc   do
393   umount ${INSTALLROOT}/sys   message+="\Z3${i}\Zn"
394   umount ${INSTALLROOT}/dev   done
395   rm ${INSTALLROOT}/root/.installrc   message+="\n"
396  }   fi
397    
398  is_uuid_supported()   # other devices
399  {   run_hardware_detection
400   if [[ -x $(type -P busybox.mkinitrd) ]]   case "${SPECIALDEVICE}" in
401     zotac*) message+=$"\n\Z2Zotac device detected.\Zn" ;;
402     rangee) message+=$"\n\Z2Rangee device detected.\Zn" ;;
403     maxdata) message+=$"\n\Z2Maxdata device detected.\Zn" ;;
404     *) message+=$"\n\ZnCommon device detected.\Zn" ;;
405     esac
406     if [[ ${FORMFACTOR} = laptop ]]
407   then   then
408   # only detect uuids if supported   message+=$"\n\ZnFormfactor Laptop, activating 'ondemand' powersaving mode.\Zn"
  if [[ ! -z $(busybox.mkinitrd | grep blkid) ]]  
  then  
  return 0  
  fi  
409   fi   fi
410    
411   return 1   messagebox -y 12 -h $"Detected hardware:" "${message}"
412  }  }
413    
414  get_uuid()  task_setup_hdd_partitions_manual()
415  {  {
416   local UUID   local i
417   local SEC_TYPE   local retval
  local TYPE  
   
  local dev="$1"  
  [[ -z ${dev} ]] && dialog_die "no dev given"  
418    
419   # check if given device is already an UUID   if [[ -z ${ALL_DISKS} ]]
  if [[ ${dev/UUID=/}x != ${dev}x ]]  
420   then   then
421   eval "${dev}"   dialog_no_harddrive_found
422     exit 1
423   else   else
424   eval $(busybox.mkinitrd blkid ${dev} | grep "${dev}:" | sed 's/.*:\ //')   HDD=$(dialog_select_target_harddrive)
425     retval=$?
426     [[ ${retval} -eq 1 ]] && return 1
427     if [[ ${retval} -eq 0 ]]
428     then
429     dialog_setup_hdd_info
430     setup_hdd_partitions_manual
431     fi
432   fi   fi
  echo "${UUID}"  
433  }  }
434    
435  install_system_settings()  task_setup_hdd_partitions_auto()
436  {  {
437   # schreibe fstab   local i
438   if is_uuid_supported   local retval
  then  
  echo -e "UUID=$(get_uuid ${ROOTHDD})\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  else  
  echo -e "${ROOTHDD}\t/\t${FORMAT_FILESYSTEM}\tnoatime\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  fi  
  # not needed busybox loads all with swapon -a, even if not mentioned in fstab  
  #echo -e "UUID='$(get_uuid ${SWAPHDD})'\tswap\tswap\tpri=1\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "proc\t/proc\tproc\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
  echo -e "shm\t/dev/shm\ttmpfs\tdefaults\t0 0" >> ${INSTALLROOT}/etc/fstab || dialog_die  
   
  # install network config skeleton  
  install -m0644 ${INSTALLROOT}/etc/alxconfig-ng/skel/net/net.eth0 ${INSTALLROOT}/etc/conf.d/ || dialog_die  
439    
440   # intel framebufer quirk   if [[ -z ${ALL_DISKS} ]]
  if [[ -e /proc/fb ]]  
441   then   then
442   if [[ ! -z $(grep 'inteldrmfb' /proc/fb) ]]   dialog_no_harddrive_found
443     exit 1
444     else
445     HDD=$(dialog_select_target_harddrive)
446     retval=$?
447     [[ ${retval} -eq 1 ]] && return 1
448     if [[ ${retval} -eq 0 ]]
449   then   then
450   fbdev=$(grep 'inteldrmfb' /proc/fb | sed 's:\([0-9]\).*:\1:')   dialog_setup_hdd_info_auto
451   if [[ ${fbdev} != 0 ]]   dialog_setup_hdd_create_partitions
452   then   setup_hdd_partitions_auto
  sed -i "s:^\(SPLASH_DEV=\).*:\1\"/dev/fb${fbdev}\":" ${INSTALLROOT}/etc/splash/splash.conf || dialog_die  
  fi  
453   fi   fi
454   fi   fi
455  }  }
456    
457  install_umount_rootfs()  task_main()
458  {  {
459   cd /   local method=0
460   umount ${INSTALLROOT}/boot || dialog_die   local retval
  umount ${INSTALLROOT} || dialog_die  
 }  
461    
462  install_do_reboot()   while [[ ${method} -le 2 ]]
463  {   do
464   reboot   method=$(dialog_main)
465     retval=$?
466     [[ ${retval} -eq 1 ]] && exit 1
467     if [[ ${retval} -eq 0 ]]
468     then
469     case ${method} in
470     "1") task_setup_system_menu ;;
471     "2") task_hardware_detection ;;
472     "3") install_do_reboot ;;
473     "4") /bin/bash --login -i ;;
474     esac
475     fi
476     done
477  }  }
478    
 #################################################  
 #     Install Ablauf Scripte #  
 #################################################  
   
479  run_install_normal()  run_install_normal()
480  {  {
481   dialog_hardware_detection   task_hardware_detection
482    
483   dialog_setup_hdd_partitions_manual   task_setup_hdd_partitions_manual
484   dialog_setup_hdd_format   dialog_setup_hdd_format
485   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
486   install_mount_rootfs   install_mount_rootfs
# Line 718  run_install_normal() Line 489  run_install_normal()
489   dialog_install_settings   dialog_install_settings
490   sleep 1   sleep 1
491   install_system_settings   install_system_settings
492   dialog_install_initrd   if is_initrd_supported
493   install_initrd_chroot   then
494     dialog_install_initrd
495     initrd_config
496     initrd_install
497     fi
498    
499   dialog_install_bootsector   dialog_install_bootsector
500   install_bootsector_chroot   bootloader_config
501     bootloader_install
502    
503   install_umount_rootfs   install_umount_rootfs
504   dialog_install_successful   dialog_install_successful
# Line 730  run_install_normal() Line 506  run_install_normal()
506    
507  run_install_auto()  run_install_auto()
508  {  {
509   dialog_hardware_detection   task_hardware_detection
510    
511   dialog_setup_hdd_partitions_auto   task_setup_hdd_partitions_auto
512   dialog_setup_hdd_format   dialog_setup_hdd_format
513   setup_hdd_format > /dev/null   setup_hdd_format > /dev/null
514   install_mount_rootfs   install_mount_rootfs
# Line 741  run_install_auto() Line 517  run_install_auto()
517   dialog_install_settings   dialog_install_settings
518   sleep 1   sleep 1
519   install_system_settings   install_system_settings
520   dialog_install_initrd   if is_initrd_supported
521   install_initrd_chroot   then
522     dialog_install_initrd
523     initrd_config
524     initrd_install
525     fi
526    
527   dialog_install_bootsector   dialog_install_bootsector
528   install_bootsector_chroot   bootloader_config
529     bootloader_install
530    
531   install_umount_rootfs   install_umount_rootfs
532   dialog_install_successful   dialog_install_successful
# Line 754  run_install_auto() Line 535  run_install_auto()
535  # set some proper traps  # set some proper traps
536  trap "trap_exit" SIGINT SIGQUIT  trap "trap_exit" SIGINT SIGQUIT
537    
538  dialog_main  task_main
539    
540  exit 0  exit 0

Legend:
Removed from v.2432  
changed lines
  Added in v.2482